﻿using System;

using Android.App;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;
using Com.Rscja.Deviceapi;
using System.Text.RegularExpressions;


namespace xm_PSAM
{
	[Activity (Label = "xm_PSAM", MainLauncher = true)]
	public class MainActivity : Activity
	{
		int count = 1;
		RadioButton card1;
		RadioButton card2;
		Spinner sppower;
		Spinner spbard;
		EditText cmd0;
		EditText cmd1;
		Button btnset;
		Button btnsend;
		Button btnclear;
		TextView labmsg;
		private ArrayAdapter bard;
		private ArrayAdapter power;
		static	PSAM psam;
		protected override void OnCreate (Bundle bundle)
		{
			base.OnCreate (bundle);
			// Set our view from the "main" layout resource
			SetContentView (Resource.Layout.Main);

			// Get our button from the layout resource,
			// and attach an event to it
			psam = PSAM.Instance;
			InitView ();
		}

		void InitView()
		{
			card1 = FindViewById<RadioButton> (Resource.Id.card1);
			card2 = FindViewById<RadioButton> (Resource.Id.card2);
			sppower = FindViewById<Spinner> (Resource.Id.sppower);
			spbard = FindViewById<Spinner> (Resource.Id.spbard);
			cmd0 = FindViewById<EditText> (Resource.Id.editcmd0);
			cmd1 = FindViewById<EditText> (Resource.Id.editcmd1);
			btnset = FindViewById<Button> (Resource.Id.btnSet);
			btnsend = FindViewById<Button> (Resource.Id.btnSend);
			btnclear = FindViewById<Button> (Resource.Id.btnClear);
			labmsg = FindViewById<TextView> (Resource.Id.labmsg);
			bard = ArrayAdapter.CreateFromResource(this,Resource.Array.bard, 
				global::Android.Resource.Layout.SimpleSpinnerItem);
			bard
				.SetDropDownViewResource (global::Android.Resource.Layout.SimpleSpinnerDropDownItem);
			spbard.Adapter = bard;
			spbard.SetSelection (0);
			power = ArrayAdapter.CreateFromResource(this,Resource.Array.power, 
				global::Android.Resource.Layout.SimpleSpinnerItem);
			power.SetDropDownViewResource (global::Android.Resource.Layout.SimpleSpinnerDropDownItem);
			sppower.Adapter = power;
			sppower.SetSelection (0);

			btnset.Click += new EventHandler (delegate {
				string card="01";
				if (card1.Checked) {
					card = "01";
				} else {
					card = "02";
				}

				psam.ExecuteCmd("02", card);

				int voltage = sppower.SelectedItemPosition;
				String cmdVoltage = "00";
				switch (voltage) {
				case 0:
					cmdVoltage = "6E";
					break;
				case 1:
					cmdVoltage = "6D";
					break;
				case 2:
					cmdVoltage = "68";
					break;
				case 3:
					cmdVoltage = "69";
					break;
				default:
					break;
				}
				int baud = spbard.SelectedItemPosition;
				String param ="000"+baud;
				String result = psam.ExecuteCmd(cmdVoltage, param);
				if (String.IsNullOrEmpty(result)) {
					result = GetString (Resource.String.GetCmdFail);
				} else {
					result=GetString(Resource.String.GetCmdSucc)+"\r\n"+result;
				}
				labmsg.Text=result;


			});

			btnsend.Click += new EventHandler (delegate {

				string cmd = cmd0.Text.Trim ();
				string data = cmd1.Text.Trim ();
				if(string.IsNullOrEmpty(cmd))
				{
					labmsg.Text=GetString(Resource.String.Inputdata);
					return;
				}

				if (!isHexNumberRex(cmd)) {
					labmsg.Text=GetString(Resource.String.Inputdatahex);
					cmd0.Focusable=true;
					return;
				}
				if(string.IsNullOrEmpty(data))
				{
					labmsg.Text=GetString(Resource.String.Inputdata);
					return;
				}
				if (!isHexNumberRex(data)) {

					labmsg.Text=GetString(Resource.String.Inputdatahex);
					cmd1.Focusable=true;
					return;
				}
				string result = psam.ExecuteCmd(cmd, data);			
				if (String.IsNullOrEmpty(result)) {
					result = GetString (Resource.String.GetCmdFail);
				} else {
					result=GetString(Resource.String.GetCmdSucc)+"\r\n"+result;
				}
				labmsg.Text=result;
			});

			btnclear.Click += new EventHandler (delegate {
				labmsg.Text="";
			});
		}

		/**
	 * 判断字符串是否是十六进制数字，使用正则表达式方式
	 * 
	 * @param str
	 *            要判断的字符串
	 * @return true是，false否
	 */
		public static Boolean isHexNumberRex(String str) {
			return Regex.IsMatch(str, "^[0-9A-Fa-f]+$");

		}
	

		protected override void OnResume()
		{
			base.OnResume ();
			new initpsam (this).Execute ();
		}
		protected override void OnPause()
		{
			base.OnPause ();
			if (psam != null)
			{
				psam.Free();
			}
		}
		protected override void OnStop()
		{
			base.OnStop ();

		}


		public override bool OnKeyDown(Keycode code,KeyEvent e)
		{
			if (code == Keycode.F9)
			{
				//Scan ();
				return true;
			}
			return base.OnKeyDown (code,e);
		}
		public override bool OnKeyUp(Keycode code,KeyEvent e)
		{
			if (code == Keycode.F9)
			{

				return true;
			}
			return base.OnKeyUp (code,e);
		}


		public class initpsam:AsyncTask{

			MainActivity mContext;
			ProgressDialog pro;
			public initpsam(MainActivity m)
			{
				mContext=m;
			}

			protected override void OnPreExecute()
			{
				pro = new ProgressDialog (mContext);
				pro.SetProgressStyle (ProgressDialogStyle.Spinner);
				pro.SetMessage ("PSAM Init...");
				pro.Show ();

			}
			#region implemented abstract members of AsyncTask

			protected override Java.Lang.Object DoInBackground (params Java.Lang.Object[] @params)
			{
				if (psam.Init()) 
				{//throw new NotImplementedException ();
					//mContext.StartScanThread ();

					return "OK";
				}
				return "";
			}

			#endregion
			protected override void  OnPostExecute(Java.Lang.Object obj)
			{
				if (obj.ToString() != "OK") {
					Toast.MakeText (mContext,"init failuer",ToastLength.Short).Show();
				}
				else
					Toast.MakeText (mContext,"init OK",ToastLength.Short).Show();
				pro.Cancel ();
			}

		}

	}
}


